/* THIS CODE IS PROPRIETARY!
 * ANY REUSE OF THIS CODE SHOULD BE UNDER PERMISSION OF THE AUTHOR
 * Authored by: A. Varvitsiotis (avarvit@iccs.ntua.gr)
 */

# define NOFUN	((unsigned char *)0)
# define GRTGL	((unsigned char *)1)
# define ACCNT	((unsigned char *)2)
# define DIAIR	((unsigned char *)3)
# define ACCDR	((unsigned char *)4)
# define CARET	((unsigned char *)5)
# define ESCMD	((unsigned char *)6)


/* This is the identity map, that does not change any key; the program
** should modify at least one key to perform the GRTGL function
*/
static unsigned char *map_eng [] = {
/*\00-	0	1	2	3	4	5	6	7	*/
/*	NUL	SOH	STX	ETX	EOT	ENQ	ACK	BEL	*/
/*	^@	^A	^B	^C	^D	^E	^F	^G	*/
	"\000",	"\001",	"\002",	"\003",	"\004",	"\005",	"\006",	"\007",
/*\01-	0	1	2	3	4	5	6	7	*/
/*	BS	HT	NL	VT	NP	CR	SO	SI	*/
/*	^H	^I	^J	^K	^L	^M	^N	^O	*/
	"\010",	"\011",	"\012",	"\013",	"\014",	"\015",	"\016",	"\017",
/*\02-	0	1	2	3	4	5	6	7	*/
/*	DLE	DC1	DC2	DC3	DC4	NAK	SYN	ETB	*/
/*	^P	^Q	^R	^S	^T	^U	^V	^W	*/
	"\020",	"\021",	"\022",	"\023",	"\024",	"\025",	"\026",	"\027",
/*\03-	0	1	2	3	4	5	6	7	*/
/*	CAN	EM	SUB	ESC	FS	GS	RS	US	*/
/*	^X	^Y	^Z	^[	^\	^]	^^	^_	*/
	"\030",	"\031",	"\032",	"\033",	"\034",	"\035",	"\036",	"\037",
	" ",	"!",	"\"",	"#",	"$",	"%",	"&",	"\'",
	"(",	")",	"*",	"+",	",",	"-",	".",	"/",
	"0",	"1",	"2",	"3",	"4",	"5",	"6",	"7",
	"8",	"9",	":",	";",	"<",	"=",	">",	"?",
	"@",	"A",	"B",	"C",	"D",	"E",	"F",	"G",
	"H",	"I",	"J",	"K",	"L",	"M",	"N",	"O",
	"P",	"Q",	"R",	"S",	"T",	"U",	"V",	"W",
	"X",	"Y",	"Z",	"[",	"\\",	"]",	"^",	"_",
	"`",	"a",	"b",	"c",	"d",	"e",	"f",	"g",
	"h",	"i",	"j",	"k",	"l",	"m",	"n",	"o",
	"p",	"q",	"r",	"s",	"t",	"u",	"v",	"w",
	"x",	"y",	"z",	"{",	"|",	"}",	"~",	"\177",
/*\20-	0	1	2	3	4	5	6	7	*/
	"\200",	"\201",	"\202",	"\203",	"\204",	"\205",	"\206",	"\207",
/*\21-	0	1	2	3	4	5	6	7	*/
	"\210",	"\211",	"\212",	"\213",	"\214",	"\215",	"\216",	"\217",
/*\22-	0	1	2	3	4	5	6	7	*/
	"\220",	"\221",	"\222",	"\223",	"\224",	"\225",	"\226",	"\227",
/*\23-	0	1	2	3	4	5	6	7	*/
	"\230",	"\231",	"\232",	"\233",	"\234",	"\235",	"\236",	"\237",

	"",	"",	"",	"",	"",	"",	"",	"",
	"",	"",	"",	"",	"",	"",	"",	"",
	"",	"",	"",	"",	"",	"",	"",	"",
	"",	"",	"",	"",	"",	"",	"",	"",
	"",	"",	"",	"",	"",	"",	"",	"",
	"",	"",	"",	"",	"",	"",	"",	"",
	"",	"",	"",	"",	"",	"",	"",	"",
	"",	"",	"",	"",	"",	"",	"",	"",
	"",	"",	"",	"",	"",	"",	"",	"",
	"",	"",	"",	"",	"",	"",	"",	"",
	"",	"",	"",	"",	"",	"",	"",	"",
	"",	"",	"",	"",	"",	"",	"",	"\377",
};


/* This is the greek map, that maps the english keys into greek
** keys. One entry should be modified by the program to perform
** the GRTGL function.
*/
static unsigned char *map_grk [] = {
	"\000",	"\001",	"\002",	"\003",	"\004",	"\005",	"\006",	"\007",
	"\010",	"\011",	"\012",	"\013",	"\014",	"\015",	"\016",	"\017",
	"\020",	"\021",	"\022",	"\023",	"\024",	"\025",	"\026",	"\027",
	"\030",	"\031",	"\032",	ESCMD,	"\034",	"\035",	"\036",	"\037",
	" ",	"!",	"\"",	"",	"$",	"%",	"",	"\'",
	"(",	")",	"*",	"+",	",",	"-",	".",	"/",
	"0",	"1",	"2",	"3",	"4",	"5",	"6",	"7",
	"8",	"9",	DIAIR,	ACCNT,	"",	"=",	"",	"",
	"@",	"",	"",	"",	"",	"",	"",	"",
	"",	"",	"",	"",	"",	"",	"",	"",
	"",	":",	"",	"",	"",	"",	"",	NOFUN,
	"",	"",	"",	"[",	"\\",	"]",	CARET,	"_",
	"`",	"",	"",	"",	"",	"",	"",	"",
	"",	"",	"",	"",	"",	"",	"",	"",
	"",	";",	"",	"",	"",	"",	"",	"",
	"",	"",	"",	"{",	"",	"}",	"\377",	"\177",
	"\200",	"\201",	"\202",	"\203",	"\204",	"\205",	"\206",	"\207",
	"\210",	"\211",	"\212",	"\213",	"\214",	"\215",	"\216",	"\217",
	"\220",	"\221",	"\222",	"\223",	"\224",	"\225",	"\226",	"\227",
	"\230",	"\231",	"\232",	"\233",	"\234",	"\235",	"\236",	"\237",
	"",	"",	"",	"",	"",	"",	"",	"",
	"",	"",	"",	"",	"",	"",	"",	"",
	"",	"",	"",	"",	"",	"",	"",	"",
	"",	"",	"",	"",	"",	"",	"",	"",
	"",	"",	"",	"",	"",	"",	"",	"",
	"",	"",	"",	"",	"",	"",	"",	"",
	"",	"",	"",	"",	"",	"",	"",	"",
	"",	"",	"",	"",	"",	"",	"",	"",
	"",	"",	"",	"",	"",	"",	"",	"",
	"",	"",	"",	"",	"",	"",	"",	"",
	"",	"",	"",	"",	"",	"",	"",	"",
	"",	"",	"",	"",	"",	"",	"",	"\377",
};

/* This is the accents map
*/
static unsigned char *map_acc [] = {
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	ESCMD,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	"\'",	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	"\'",
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,  NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	ACCDR,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	"",	NOFUN,	NOFUN,	NOFUN,	"",	NOFUN,	NOFUN,
	"",	"",	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	"",
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	"",	NOFUN,
	NOFUN,	"",	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	"",	NOFUN,	NOFUN,	NOFUN,	"",	NOFUN,	NOFUN,
	"",	"",	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	"",
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	"",	NOFUN,
	NOFUN,	"",	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
};

/* This is the diairesis map
*/
static unsigned char *map_drs [] = {
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	ESCMD,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	"\"",	NOFUN,	"\"",	NOFUN,	NOFUN,	NOFUN,	NOFUN,	ACCDR,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,  NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	ACCDR,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	"",	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	"",	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	"",	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	"",	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
};

/* This is the accented diairesis map
*/
static unsigned char *map_acd [] = {
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	ESCMD,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	"",	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,  NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	"",	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	"",	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
};

/* This is the caret map */
static unsigned char *map_car [] = {
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	"\033",	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	"",	"",	"",	NOFUN,	NOFUN,	NOFUN,	NOFUN,	"",
	NOFUN,	NOFUN,	NOFUN,	"",	NOFUN,	"",	"",	"",
	"",	"",	"",	"",	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	"",	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	"^",	NOFUN,
	"",	NOFUN,	NOFUN,	"",	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,	NOFUN,
};

